m = 30;
alpha = 70;

%load object1: bird02
load('resources\bird02-contour.mat');
load('resources\bird02-endpoints.mat');
load('resources\bird02-pathes.mat');
load('resources\bird02-radiMatrix.mat');
load('resources\bird02-skeleton.mat');

contour1 = mycontour;
endpoints1 = endpoints;
pathes1 = pathes;
radiMatrix1 = radiMatrix;
skeleton1 = skeleton;
normfac1 = sum(sum(contour1));
clear mycontour;
clear endpoints;
clear pathes;
clear radiMatrix;
clear skeleton;

%load object1: bird04
load('resources\bird04-contour.mat');
load('resources\bird04-endpoints.mat');
load('resources\bird04-pathes.mat');
load('resources\bird04-radiMatrix.mat');
load('resources\bird04-skeleton.mat');

contour2 = mycontour;
endpoints2 = endpoints;
pathes2 = pathes;
radiMatrix2 = radiMatrix;
skeleton2 = skeleton;
normfac2 = sum(sum(contour1));
clear mycontour;
clear endpoints;
clear pathes;
clear radiMatrix;
clear skeleton;

sep1 = size(endpoints1,1);
sep2 = size(endpoints2,1);

DistanceMatrix = zeros(sep1,sep2);

for i = 1:sep1
    point1x = endpoints1(i,1);
    point1y = endpoints1(i,2);
    for j = 1:sep2
        point2x = endpoints2(j,1);
        point2y = endpoints2(j,2);
        [dissimilarity] = f_point_distance(point1x,point1y,point2x,point2y,pathes1,pathes2, normfac1, normfac2, radiMatrix1, radiMatrix2, m, alpha);
        DistanceMatrix(i,j) = dissimilarity;
    end
end

%finally, we compute the total disimilarity between object1 and object2
%with the Hungarian Algorithm on DistanceMatrix. Since object1 and object2
%may have different numbers of end nodes, the total dissimilarity value
%should include the penalty for each nodes that did not find any partner.

%To achieve this, we simply add additional rows with a constant value to
%DistanceMatrix so that DistanceMatrix becoomes a square matrix. The
%constant value const is the average of all the other values in
%DistanceMatrix.

[NewDistanceMatrix] = f_Adding_Dummy(DistanceMatrix);

%Hungarian algorithm to get dissimilarity and corresponding
[corresponding, dissimilarity] = f_Hungarian_Corresponding(NewDistanceMatrix);

